#include "stm32f4xx.h"
#include "FreeRTOS.h"
#include "task.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>



static void TaskA(void *pvParameters)
{
    int A=0;
    
    pvParameters = pvParameters;
    for(;;) 
    {
      A++;
      GPIO_SetBits(GPIOD, GPIO_Pin_13);
      vTaskDelay(500);
      GPIO_ResetBits(GPIOD, GPIO_Pin_13);
      vTaskDelay(500);
    }
}


static void TaskB(void *pvParameters)
{
    int A=0;
    
    pvParameters = pvParameters;
    for(;;) 
    {
        A++;
        GPIO_SetBits(GPIOD, GPIO_Pin_12);
        vTaskDelay(200);
        GPIO_ResetBits(GPIOD, GPIO_Pin_12);
        vTaskDelay(200);
    }
}

static void TaskC(void *pvParameters)
{
    int A=0;
    
    pvParameters = pvParameters;
    for(;;) 
    {
        A++;
        GPIO_SetBits(GPIOD, GPIO_Pin_14);
        vTaskDelay(700);
        GPIO_ResetBits(GPIOD, GPIO_Pin_14);
        vTaskDelay(700);
    }
}

static void TaskD(void *pvParameters)
{
    int A=0;
    
    pvParameters = pvParameters;
    for(;;) 
    {
        A++;
        GPIO_SetBits(GPIOD, GPIO_Pin_15);
        vTaskDelay(1000);
        GPIO_ResetBits(GPIOD, GPIO_Pin_15);
        vTaskDelay(1000);
    }
}


void initx(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure;

  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE);
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12 | GPIO_Pin_13| GPIO_Pin_14| GPIO_Pin_15;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_Init(GPIOD, &GPIO_InitStructure);
}

int main(void)
{
    initx();

    xTaskCreate(TaskA, (signed char*)"TaskA", 128, NULL, tskIDLE_PRIORITY+1, NULL);
    xTaskCreate(TaskB, (signed char*)"TaskB", 128, NULL, tskIDLE_PRIORITY+1, NULL);
    xTaskCreate(TaskC, (signed char*)"TaskC", 128, NULL, tskIDLE_PRIORITY+1, NULL);
    xTaskCreate(TaskD, (signed char*)"TaskD", 128, NULL, tskIDLE_PRIORITY+1, NULL);
    vTaskStartScheduler();
}
